<template>
  <div>
    <el-button
      style="float: right"
      size="small"
      icon="el-icon-printer"
      @click="PrintAction"
      type="primary"
      >打印
    </el-button>

     <el-button
      style="float: right;margin-right:10px"
      size="small"
      @click="exportList"
      type="primary"
      >导出
    </el-button>

    <div class="cell clearfix">
      <el-input
        size="small"
        style="width: 400px;"
        class="filter-item"
        v-model.trim="searchKey"
        placeholder="单据编码/制单人/药品名称"
      />
      <el-button
        size="small"
        class="filter-item"
        type="primary"
        icon="el-icon-search"
        @click="search"
        >搜索</el-button
      >
      <div style="margin-left:10px;">
        <label class="title"><span class="name">日期查询</span> : </label>
        <el-date-picker
          size="small"
          v-model="start_time"
          prefix-icon="el-icon-date"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          @change="startTimeChange"
        ></el-date-picker>
        <span class="cellLine"> - </span>
        <el-date-picker
          size="small"
          v-model="end_time"
          prefix-icon="el-icon-date"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          @change="endTimeChange"
        ></el-date-picker>
      </div>
    </div>

    

    <!-- <div class="cell clearfix">
      <label class="title"><span class="name">单据类型</span> : </label>
      <el-select
        size="small"
        v-model="order_type"
        clearable
        placeholder="单据类型"
        @change="changeType"
      >
        <el-option
          v-for="item in orderTypeArr"
          :key="item.value"
          :label="item.label"
          :value="item.value"
        >
        </el-option>
      </el-select>
    </div> -->

    <!-- <div class="cell clearfix">
      <label class="title"><span class="name">其它</span> : </label>
      <el-select
        size="small"
        v-model="manufacturer_id"
        clearable
        placeholder="厂商"
        @change="changeManufacturer"
      >
        <el-option
          v-for="item in manufacturer"
          :key="item.id"
          :label="item.manufacturer_name"
          :value="item.id"
        >
        </el-option>
      </el-select>
    </div> -->

    <el-row :gutter="12" style="margin-top: 10px">
      <el-table
        :data="cancelStockDate"
        :class="signAndWeighBoxPatients"
        border
        highlight-current-row
        ref="multipleTable"
        @selection-change="select"
        :row-style="{ color: '#303133' }"
        :header-cell-style="{
          backgroundColor: 'rgb(245, 247, 250)',
          color: '#606266'
        }"
      >
        <el-table-column label="单据编号" align="center" width="200">
          <template slot-scope="scope">
            {{scope.row.warehousing_order}}
          </template>
        </el-table-column>

        <el-table-column label="药品类型" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.drug_type == 1">西药</span>
            <span v-if="scope.row.drug_type == 2">草药</span>
            <span v-if="scope.row.drug_type == 3">成药</span>
          </template>
        </el-table-column>

        <el-table-column label="药品名称" align="center">
          <template slot-scope="scope">
            {{scope.row.drug_name}}
          </template>
        </el-table-column>

        <el-table-column label="规格型号" align="center">
          <template slot-scope="scope">
           <!-- {{scope.row.drug_spec}} -->
           {{scope.row.dose}}{{scope.row.dose_unit}} * {{scope.row.min_number}}{{scope.row.min_unit}} / {{scope.row.max_unit}}
          </template>
        </el-table-column>

        <!-- <el-table-column label="单据类型" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.type == 1">药品入库单</span>
            <span v-if="scope.row.type == 2">其他</span>
          </template>
        </el-table-column> -->

        <el-table-column label="操作时间" align="center">
          <template slot-scope="scope">
            <span>{{getTime(scope.row.ctime)}}</span>
          </template>
        </el-table-column>
        <el-table-column label="制单人" align="center">
          <template slot-scope="scope">
           {{getAdminUser(scope.row.creater)}}
          </template>
        </el-table-column>
        <el-table-column label="进货价" align="center">
          <template slot-scope="scope">
            {{scope.row.price}}
          </template>
        </el-table-column>
        <el-table-column label="数量" align="center">
          <template slot-scope="scope">
            {{scope.row.warehousing_count}}
          </template>
        </el-table-column>
        <el-table-column label="总价" align="center">
          <template slot-scope="scope">
            {{scope.row.total_price}}
          </template>
        </el-table-column>
      </el-table>

      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :page-sizes="[10, 50, 100]"
        :page-size="10"
        background
        style="margin-top:20px;float: right"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total"
      >
      </el-pagination>
    </el-row>
  </div>
</template>

<script>
import { uParseTime } from "@/utils/tools";
import { fetchAllAdminUsers } from "@/api/doctor";
import { GetAllConfig } from "@/api/stock";
import { getDrugIndetail,getDrugWarehouseInfoPrint} from "@/api/drug/drug_stock"
export default {
  name: "stockInDetail",

  created() {
    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.end_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    nowDate.setMonth(nowDate.getMonth() - 1);
    nowYear = nowDate.getFullYear();
    nowMonth = nowDate.getMonth() + 1;
    nowDay = nowDate.getDate();
    this.start_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    this.GetConfigInfo()
    this.fetchAllAdminUsers()
    //获取入库单数据
    this.getlist()
    this.getDrugWarehouseInfoPrint() 

  },
  data() {
    return {
      orderTypeArr: [
        { value: 1, label: "药品入库单" },
        { value: 2, label: "其他入库单" }
      ],
      newDate: [{ name: "合计", num: "111111" }],

      searchKey: "",
      type: 1,
      page: 1,
      limit: 10,
      manufacturer_id: "",
      dealer_id: "",
      order_type: 1,
      checked: false,
      total: 0,
      pageTotal: 0,
      pageSelect: 0,
      adminUserOptions: [],
      multipleSelection: [],
      signAndWeighBoxPatients: "sign-and-weigh-box-patients",
      start_time: "",
      cancelStockDate: [],
      end_time: "",
      goodType: [],
      goodInfo: [],
      manufacturer: [],
      selectedTableData: [],
      dealer: [],
      tableList:[],
      tabelePrintList:[],
    };
  },
  methods: {
    changeType: function(val) {
     
      this.order_type = val;
     
    },
    changeManufacturer: function(val) {
      this.manufacturer_id = val;
      
    },
    changeDealer: function(val) {
      this.dealer_id = val;
     
    },
    search: function() {
      this.getlist()
    },
    getTime: function(val) {
      if (val == 0) {
        return "";
      } else {
        return uParseTime(val, "{y}-{m}-{d}");
      }
    },
    AddNewOrder: function() {
   
    },
  
   
    fetchAllAdminUsers() {
      fetchAllAdminUsers().then(response => {
        console.log(response);
        if (response.data.state == 1) {
          this.adminUserOptions = response.data.data.users;
          console.log("医生护士",this.adminUserOptions)
        }
      });
    },
    handleSelectionChange: function(val) {
      this.multipleSelection = val;
    },
    handleSizeChange(val) {
      this.limit = val;
      this.getlist()
    },
    handleCurrentChange(val) {
      this.page = val;
      this.getlist()
     
    },
    startTimeChange(val) {
      var time = this.getTimestamp(val) - this.getTimestamp(this.end_time);
      if (time > 0) {
        this.$message.error("结束时间不能小于开始时间");
        this.start_time = "";
      } else {
        this.getlist();
      }
    },
    endTimeChange(val) {
      var time = this.getTimestamp(val) - this.getTimestamp(this.start_time);
      if (time < 0) {
        this.$message.error("结束时间不能小于开始时间");
        this.end_time = "";
      } else {
        this.getlist();
      }
    },
    getTimestamp(time) {
      // 把时间日期转成时间戳
      return new Date(time).getTime() / 1000;
    },
    calculate: function(val) {
      return Math.round(parseFloat(val) * 100) / 100;
    },

     GetConfigInfo(){
      GetAllConfig().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.manufacturer = response.data.data.manufacturer;
          this.dealer = response.data.data.dealer;
          this.goodInfo = response.data.data.goodInfo;
          this.goodType = response.data.data.goodType;
        }
      });
    },

   
    getlist(){
       var params = {
        start_time:this.start_time,
        end_time:this.end_time,
        order_type:this.order_type,
        manufacturer_id:this.manufacturer_id,
        keyword:this.searchKey,
        limit:this.limit,
        page:this.page,
       }
      getDrugIndetail(params).then(response=>{
        if(response.data.state == 1){
          var drugInOrder = response.data.data.detail
          console.log("drug3434444",drugInOrder)
          this.cancelStockDate = drugInOrder
           let objInfo = {}
          drugInOrder.forEach((item,index)=>{
             let { drug_id } = item
             if(!objInfo[drug_id]){
               objInfo[drug_id] = {
                 drug_id,
                 child:[],
                 drug_name:item.drug_name,
                 drug_spec:item.drug_spec,
                 min_unit:item.min_unit,
                 warehousing_count:0,
                 price:item.price,
                 remark:item.remark,
                 total_price:0,
                 dose:item.dose,
                 dose_unit:item.dose_unit,
                 min_number:item.min_number,
                 max_unit:item.max_unit
               }
             }
          })
          let list = Object.values(objInfo);
          console.log("list22333333",list)
         for(let i=0;i<drugInOrder.length;i++){
            list.map(item=>{
              if(drugInOrder[i].drug_id == item.drug_id){
                 item.child.push(drugInOrder[i])
              }
            })
          }
          console.log("list2334444",list)
          for(let i=0;i<list.length;i++){
            for(let j=0;j<list[i].child.length;j++){
              if(list[i].child[j].warehousing_count!=null || list[i].child[j].warehousing_count != "" || list[i].child[j].warehousing_count!=0){
                list[i].warehousing_count += list[i].child[j].warehousing_count
                
              }
            }
          }
          for(let i=0;i<list.length;i++){
            list[i].total_price = list[i].warehousing_count * list[i].price  
          }
          console.log("list666666666",list)
          this.tableList = list
          var total = response.data.data.total
          this.total = total
        }
      })
    },
    getDrugWarehouseInfoPrint(){
      var params = {
        start_time:this.start_time,
        end_time:this.end_time,
        order_type:this.order_type,
      }
      console.log("params2222",params)
     getDrugWarehouseInfoPrint(params).then(response=>{
          if(response.data.state == 1){
            var list = response.data.data.list
            console.log("入库单详情",list)
            this.tabelePrintList = list
          }   
      })
    },
    PrintAction(){
      console.log("打印",this.order_type)
      this.$router.push("/stock/drugprint?start_time="+this.start_time+"&end_time="+this.end_time+"&order_type="+this.order_type+"&manufacturer_id="+this.manufacturer_id+"&keyword="+this.keyword+"&limit="+this.limit+"&page="+this.page)
    },
    select(){

    },
    getAdminUser(id){
      var name = ""
      for(let i=0;i<this.adminUserOptions.length;i++){
          if(id == this.adminUserOptions[i].id){
             name = this.adminUserOptions[i].name
          }
      }
      return name
    },
     exportList(){
        for(let i=0;i<this.tabelePrintList.length;i++){
          this.tabelePrintList[i].index = i+1
          this.tabelePrintList[i].drug_name = this.tabelePrintList[i].XtBaseDrug.drug_name

          this.tabelePrintList[i].unit = this.tabelePrintList[i].XtBaseDrug.dose + this.tabelePrintList[i].XtBaseDrug.dose_unit + "*" + this.tabelePrintList[i].XtBaseDrug.min_number +this.tabelePrintList[i].XtBaseDrug.min_unit +"/"+this.tabelePrintList[i].XtBaseDrug.max_unit
        }
        
       import('@/vendor/Export2Excel').then(excel => {
       const tHeader = ['序号','药品名称', '规格型号', '单位','数量','单价','总价','备注']
       const filterVal = ['index','drug_name', 'unit', 'min_unit','warehousing_count','price','total_price','remark']
       console.log("表格22222222",this.tabelePrintList)
       let obj = {'index':'合计','total_price':0}
       for(let i=0;i<this.tabelePrintList.length;i++){
         obj.total_price += this.tabelePrintList[i].price * this.tabelePrintList[i].warehousing_count
       }
       for(let j=0;j<this.tabelePrintList.length;j++){
         this.tabelePrintList[j].total_price = this.tabelePrintList[j].total_price.toFixed(2)
       }
       obj.total_price = obj.total_price.toFixed(2)
       this.tabelePrintList.push(obj)
       const data = this.formatJson(filterVal, this.tabelePrintList)
       console.log("data",data)
       
        excel.export_json_to_excel({
           header: tHeader,
           data,
           filename: '药品入库明细'
         })
          this.downloadLoading = false
        })
       },
     formatJson(filterVal, jsonData) {
        return jsonData.map(v => filterVal.map(j => v[j]));
     },
  }
};
</script>

<style rel="stylesheet/css" lang="scss" scoped>
.information {
  border: 1px #dcdfe6 solid;
  padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }
}

.edit_separater {
  border-top: 1px solid rgb(233, 233, 233);
  margin-top: 15px;
  margin-bottom: 15px;
}
</style>

<style>
.sign-and-weigh-box .sign-and-weigh-box-patients .cell {
  font-size: 12px;
}

.sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
  background: #6fb5fa;
}

.count {
  color: #bd2c00;
}
.el-table td,
.el-table th.is-leaf,
.el-table--border,
.el-table--group {
  border-color: #d0d3da;
}
.el-table--border::after,
.el-table--group::after,
.el-table::before {
  background-color: #d0d3da;
}
</style>
